//+------------------------------------------------------------------+
//|                                               e-AlligatorZZZ.mq4 |
//|                                      Copyright  2011, ZZZEROXXX |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  5212

extern double Lots               = 0.1;
extern string MM                 = "===Money management params===";
extern bool UseMM                = false;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern string IndParams1         = "===Alligator params===";
extern double BlueLine           = 13;
extern double BlueShift          = 8;
extern double RedLine            = 8;
extern double RedShift           = 5;
extern double LimeLine           = 5;
extern double LimeShift          = 3;
extern string MAMethodStr        = "SMA=0,EMA=1,Smoothed=2,Linear weighted=3";
extern int MAMethod              = 2;
extern string AppliedPriceStr    = "Close=0,Median=4,Typical=5,Weighted close=6";
extern int AppliedPrice          = 4;
extern int Shift                 = 1;
extern string CloseCondString    = "===Close conditions===";
extern bool Reverce         = true;
extern bool CloseAfterRed        = false;
extern bool DoubleCloseAfterRed  = false;
string SLTPStr            = "=== StopLoss && Takeprofit, ignore if 0 ===";
double StopLoss           = 0;
double TakeProfit         = 0;
extern string OsMAAdditionsStr = " ===  OsMA=== ";
extern bool EnableOsMA     = false;
extern double OsFastMA       = 6;
extern double OsSlowMA       = 13;
extern double OsSignalMA     = 5;
extern int MaxOrders      =1;


double Bl=0;
double Rd=0;
double Lm=0;

bool buycond=false;
bool sellcond=false;

bool closebuycond=false;
bool closesellcond=false;

double TP=0;
double SL=0;

double osma1=0;
double osma2=0;
double osma3=0;

datetime osmasignalbartime=0;


void CalculateOSMA()
{
//if (MathAbs(CalculateCurrentOrders(Symbol()))>=MaxOrders) return;

if (osmasignalbartime!=iTime(Symbol(),0,0))
{
osma1=iCustom(Symbol(),0,"OsMA",OsFastMA,OsSlowMA,OsSignalMA,0,1);
osma2=iCustom(Symbol(),0,"OsMA",OsFastMA,OsSlowMA,OsSignalMA,0,2);
osma3=iCustom(Symbol(),0,"OsMA",OsFastMA,OsSlowMA,OsSignalMA,0,3);

CheckForClose();

if (CalculateCurrentOrders(Symbol())>0) //  
{
if (EnableBuys()==true && osma2<0 && osma3>osma2 && osma1>osma2 && Close[1]>Lm) {buycond=true;sellcond=false;CheckForOpen();}
}

if (CalculateCurrentOrders(Symbol())<0) //  
{
if (EnableSells()==true && osma2>0 && osma3<osma2 && osma1<osma2 && Close[1]<Lm) {sellcond=true;buycond=false;CheckForOpen();}
}

osmasignalbartime=iTime(Symbol(),0,0);
}

}


bool EnableSells()
{
if (Lm<Rd && Rd<Bl) return(true); else return(false);
}

bool EnableBuys()
{
if (Lm>Rd && Rd>Bl) return(true); else return(false);
}


void CalculateMovings()
{
Bl=iAlligator(Symbol(),0,BlueLine,BlueShift,RedLine,RedShift,LimeLine,LimeShift,MAMethod,AppliedPrice,MODE_GATORJAW,Shift);
Rd=iAlligator(Symbol(),0,BlueLine,BlueShift,RedLine,RedShift,LimeLine,LimeShift,MAMethod,AppliedPrice,MODE_GATORTEETH,Shift);
Lm=iAlligator(Symbol(),0,BlueLine,BlueShift,RedLine,RedShift,LimeLine,LimeShift,MAMethod,AppliedPrice,MODE_GATORLIPS,Shift);

//==============================  ================================================
if (Reverce==true && CloseAfterRed==false && DoubleCloseAfterRed==false && StopLoss==0) // 
{
if (EnableBuys()==true) {buycond=true; sellcond=false;} 
if (EnableSells()==true) {buycond=false; sellcond=true;}
}

if (CloseAfterRed==true && Reverce==false && DoubleCloseAfterRed==false)//    
{
if (EnableBuys()==true && Close[1]>Rd) {buycond=true; sellcond=false;} 
if (EnableSells() && Close[1]<Rd) {buycond=false; sellcond=true;}
}

if (DoubleCloseAfterRed==true && Reverce==false && CloseAfterRed==false)//    
{
if (EnableBuys()==true && Close[1]>Rd && Close[2]>Rd) {buycond=true; sellcond=false;} 
if (EnableSells() && Close[1]<Rd && Close[2]<Rd) {buycond=false; sellcond=true;}
}


//==========================  =======================================
if (Reverce==true && CloseAfterRed==false && DoubleCloseAfterRed==false) // 
{
if (EnableBuys()==true) {closesellcond=true; closebuycond=false;}
if (EnableSells()==true) {closebuycond=true; closesellcond=false;}
}

if (CloseAfterRed==true && Reverce==false && DoubleCloseAfterRed==false)//    
{
if (CalculateCurrentOrders(Symbol())<0 && Close[1]>Rd) {closesellcond=true; closebuycond=false;}
if (CalculateCurrentOrders(Symbol())>0 && Close[1]<Rd) {closesellcond=false; closebuycond=true;}
}

if (DoubleCloseAfterRed==true && Reverce==false && CloseAfterRed==false)//    
{
if (CalculateCurrentOrders(Symbol())<0 && Close[1]>Rd && Close[2]>Rd) {closesellcond=true; closebuycond=false;}
if (CalculateCurrentOrders(Symbol())>0 && Close[1]<Rd && Close[2]<Rd) {closesellcond=false; closebuycond=true;}
}




}


int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }

double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   if (UseMM==true) return(lot); else return(Lots);
  }



void CheckForOpen()
  {
   int    res;
//---- sell conditions
   if(sellcond==true)  
     {
      if (StopLoss!=0) SL=Bid+(NormalizeDouble(Point*StopLoss,Digits)); else SL=0;
      if (TakeProfit!=0) TP=Bid-(NormalizeDouble(Point*TakeProfit,Digits)); else TP=0;
      
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,SL,TP,"",MAGICMA,0,Red);
      sellcond=false;
      osmasignalbartime=iTime(Symbol(),0,0);
      return;
     }
//---- buy conditions
   if(buycond==true)  
     {
      if (StopLoss!=0) SL=Ask-(NormalizeDouble(Point*StopLoss,Digits)); else SL=0;
      if (TakeProfit!=0) TP=Ask+(NormalizeDouble(Point*TakeProfit,Digits)); else TP=0;
      
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,SL,TP,"",MAGICMA,0,Blue);
      buycond=false;
      osmasignalbartime=iTime(Symbol(),0,0);
      return;
     }
//----
  }


void CheckForClose()
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(closebuycond==true) {OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         closebuycond=false; buycond=false;}
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(closesellcond==true) {OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         closesellcond=false; sellcond=false;}
         break;
        }
     }

}

void start()
  {
   if(Bars<100 || IsTradeAllowed()==false) return;
   CalculateMovings();
   if (CalculateCurrentOrders(Symbol())!=0 && EnableOsMA==true) CalculateOSMA();
   
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else 
   {
   CheckForClose();
   }
   
   
//----
  }
//+------------------------------------------------------------------+